'********************************************************************
' MyLittleGrid.inc   by James E. Klutho  Copyright May,2008 by James E. Klutho
' EBasic
'********************************************************************
'CONSTANTS
'********************************************************************

CONST MLG_NULL              = 0
CONST MLG_MAXCELLLEN        = 1024
CONST WM_USER = 0x400
'Command Messages
CONST MLG_REFRESH           = WM_USER + 1
CONST MLG_MAKEDEFHEADERS    = WM_USER + 2
CONST MLG_INSERTCOLBEFORE   = WM_USER + 3
CONST MLG_INSERTCOLAFTER    = WM_USER + 4
CONST MLG_INSERTROWBEFORE   = WM_USER + 5
CONST MLG_INSERTROWAFTER    = WM_USER + 6
CONST MLG_DELETECOLS        = WM_USER + 7
CONST MLG_DELETEROWS        = WM_USER + 8
CONST MLG_REDIMARRAY        = WM_USER + 9
CONST MLG_MAKELONG          = WM_USER + 10
CONST MLG_CLEARGRID         = WM_USER + 11
CONST MLG_UNDO              = WM_USER + 12
CONST MLG_REDIMARRAYEX      = WM_USER + 13
CONST MLG_HIDECOLUMN        = WM_USER + 14
CONST MLG_SORT              = WM_USER + 15
'Set Data Messages
CONST MLG_SETNUMFORMATROW   = WM_USER + 16
CONST MLG_SETNUMFORMATCOL   = WM_USER + 17
CONST MLG_SETWORKBOOKPROP   = WM_USER + 18
CONST MLG_SETSELECTED       = WM_USER + 20
CONST MLG_SETROWFORMAT      = WM_USER + 21
CONST MLG_SETTOPROW         = WM_USER + 22
CONST MLG_SETCOLFORMAT      = WM_USER + 23
CONST MLG_SETROWCOLTEMPLATE = WM_USER + 24
CONST MLG_SETGRIDEXSTYLE    = WM_USER + 25
CONST MLG_SETDIRTYFLAG      = WM_USER + 26
CONST MLG_SETLEFTCOL        = WM_USER + 27
CONST MLG_SETSKIPRECFLAG    = WM_USER + 28
CONST MLG_SETROWEXTRA       = WM_USER + 29
CONST MLG_SETCOLEXTRA       = WM_USER + 30
CONST MLG_SETCOLWIDTH       = WM_USER + 31
CONST MLG_SETCELL           = WM_USER + 32 'SendMessage cntl, CONST MLG_SETCELL, MAKLNG(row,col),varptr(asciiz))
CONST MLG_SETCELLR          = WM_USER + 33
CONST MLG_SETDIRTYFLAGZERO  = WM_USER + 34
CONST MLG_SETNUMFORMATSTR   = WM_USER + 35
CONST MLG_SETCELLEX         = WM_USER + 36 'zstring in zBuffer
CONST MLG_SETCELLREX        = WM_USER + 37 'zstring in zBuffer
CONST MLG_SETBUFFER         = WM_USER + 38 'zBuffer
CONST MLG_SETHEADERCOLOR    = WM_USER + 39
'Get Data Messages
CONST MLG_GETWORKBOOKPROP   = WM_USER + 19
CONST MLG_GETSELECTED       = WM_USER + 40
CONST MLG_GETROWFORMAT      = WM_USER + 41
CONST MLG_GETTOPROW         = WM_USER + 42
CONST MLG_GETCOLFORMAT      = WM_USER + 43
CONST MLG_GETDIRTYFLAG      = WM_USER + 44
CONST MLG_GETROWCOLTOT      = WM_USER + 45
CONST MLG_GETROWCOLDIM      = WM_USER + 46
CONST MLG_GETLEFTCOL        = WM_USER + 47
CONST MLG_GETOLDCELL        = WM_USER + 48
CONST MLG_GETUNDO           = WM_USER + 49
CONST MLG_GETCELLTYPE       = WM_USER + 50
CONST MLG_GETROWEXTRA       = WM_USER + 51
CONST MLG_GETCOLEXTRA       = WM_USER + 52
CONST MLG_GETCOLWIDTH       = WM_USER + 53
CONST MLG_GETCELL           = WM_USER + 54
CONST MLG_GETBUILD          = WM_USER + 55
CONST MLG_GETROWCOLALLBLOCKSEL   = WM_USER + 56
CONST MLG_GETROWBLOCKSEL    = WM_USER + 57
CONST MLG_GETCOLBLOCKSEL    = WM_USER + 58
CONST MLG_GETMENUHANDLE     = WM_USER + 59
CONST MLG_GETROWCOLDIMEX    = WM_USER + 60
CONST MLG_GETROWCOLTOTEX    = WM_USER + 61
CONST MLG_GETROWBLOCKSELEX  = WM_USER + 62
CONST MLG_GETCOLBLOCKSELEX  = WM_USER + 63
CONST MLG_GETOLDCELLEX      = WM_USER + 64
CONST MLG_GETCELLEX         = WM_USER + 65   'string in buffer
CONST MLG_GETSELECTEDEX     = WM_USER + 66
CONST MLG_GETBUFFER         = WM_USER + 67
CONST MLG_GETARRAYPTR       = WM_USER + 68
CONST MLG_GETEDITHANDLE     = WM_USER + 69

'Notifications
CONST MLGN_RETURN           = WM_USER + 70
CONST MLGN_DELETE           = WM_USER + 71
CONST MLGN_TAB              = WM_USER + 72
CONST MLGN_CHARPRESSED      = WM_USER + 73
CONST MLGN_ESCAPEPRESSED    = WM_USER + 74

CONST MLGN_ROWDIRTY         = WM_USER + 75
CONST MLGN_CELLDIRTY        = WM_USER + 76
CONST MLGN_ROWALTERED       = WM_USER + 77
CONST MLGN_CELLALTERED      = WM_USER + 78
CONST MLGN_DATEPROBLEM      = WM_USER + 79

CONST MLGN_CHECKCHANGED     = WM_USER + 80
CONST MLGN_COMBOCHANGED     = WM_USER + 81
CONST MLGN_COLWIDTHCHANGED  = WM_USER + 82

CONST MLGN_SELCHANGE        = WM_USER + 83
CONST MLGN_ROWSELCHANGE     = WM_USER + 84
CONST MLGN_COLSELCHANGE     = WM_USER + 85
CONST MLGN_ROWCOLALLBLOCKSEL= WM_USER + 86
CONST MLGN_ROWCHANGE        = WM_USER + 87

CONST MLGN_REDIMFAILED      = WM_USER + 88
CONST MLGN_WANTNEWREC       = WM_USER + 89
CONST MLGN_MADENEWREC       = WM_USER + 90

CONST MLGN_RCLICKMENU       = WM_USER + 91
CONST MLGN_RIGHTCLICK       = WM_USER + 92
CONST MLGN_PASTE            = WM_USER + 93

CONST MLGN_SHEETRCLICK      = WM_USER + 94
CONST MLGN_SHEETSELECT      = WM_USER + 95
CONST MLGN_RCLICKTABMENU    = WM_USER + 96

CONST MLGN_SHEETNAMECHANGE  = WM_USER + 97
CONST MLGN_SHEETPOSCHANGE   = WM_USER + 98
CONST MLGN_SHEETCOLORCHANGE = WM_USER + 99
CONST MLGN_SHEETADDED       = WM_USER + 100
CONST MLGN_SHEETDELETED     = WM_USER + 101

CONST MLGN_COLSIZEDOUBLECLICK   = WM_USER + 110
CONST MLGN_THEMECHANGED     = WM_USER + 111
''Worksheet Messages
CONST MLG_ADDSHEET          = WM_USER + 120
CONST MLG_DELETESHEET       = WM_USER + 121
CONST MLG_NAMESHEET         = WM_USER + 122
CONST MLG_SELECTSHEET       = WM_USER + 123
CONST MLG_SWAPSHEET         = WM_USER + 124
CONST MLG_SHOWSHEETTABS     = WM_USER + 125
CONST MLG_COLORSHEETTAB     = WM_USER + 126
CONST MLG_GETSHEETINFO      = WM_USER + 127
CONST MLG_SETSHEETUSER      = WM_USER + 128
CONST MLG_GETSHEETUSER      = WM_USER + 129

'Format Override   '65000, by 65000 limit
CONST MLG_CREATEFORMATOVERRIDE  = WM_USER + 140
CONST MLG_DELETEFORMATOVERRIDE  = WM_USER + 141
CONST MLG_SETFORMATOVERRIDE     = WM_USER + 142
CONST MLG_GETFORMATOVERRIDE     = WM_USER + 143
CONST MLG_GETFORMATOVERRIDEROWCOL = WM_USER + 144
CONST MLG_FREEZE                = WM_USER + 145
CONST MLG_GETNOTIFYPARAM        = WM_USER + 146

CONST MLG_UNFREEZEALL       = 0
CONST MLG_FREEZEROW         = 1
CONST MLG_UNFREEZEROW       = 2
CONST MLG_FREEZECOL         = 3
CONST MLG_UNFREEZECOL       = 4

'Cell Types
CONST MLG_TYPE_EDIT         = 0 'default  - may be overridden
CONST MLG_TYPE_EDITFORCE    = 1
CONST MLG_TYPE_CHECKBOX     = 2
CONST MLG_TYPE_COMBOSTATIC  = 3
CONST MLG_TYPE_COMBOEDIT    = 4
'Write Lock
CONST MLG_NOLOCK            = 0
CONST MLG_LOCK              = 1
CONST MLG_LOCK_SKIPROW      = -1 'Will not allow a locked row to be selected
'High Light a row
CONST MLG_NOHILITE          = 0
CONST MLG_HILITE            = -1
'Case Formats
CONST MLG_NOCASE            = 0
CONST MLG_UCASE             = 1
CONST MLG_LCASE             = -1
'Justification formats
CONST MLG_JUST_LEFT         = 0
CONST MLG_JUST_RIGHT        = 1
CONST MLG_JUST_CENTER       = 2
'Date formats
CONST MMDDYYYY              = 1
CONST MMDDYYYYH             = 2  'Dot instead of a slash
CONST DDMMYYYY              = 3
CONST DDMMYYYYH             = 4  'Dot instead of a slash
CONST MMYYYY                = 5
CONST MMYYYYH               = 6  'Dot instead of a slash
CONST YYYYMMDD              = 7
CONST YYYYMMDDH             = 8  'Dot instead of a slash
CONST YYYYMM                = 9
CONST YYYYMMH               = 10  'Dot instead of a slash
'Column Hide
CONST MLG_HIDECOL           = 0
CONST MLG_UNHIDECOL         = 1
CONST MLG_UNHIDEALLCOLS     = 2
'Sorting
CONST MLG_ASCEND            = 0
CONST MLG_DESCEND           = 1

'Redimensioning Error Codes

CONST MLG_ERR_TOTROWS1       =  1 'Requested Total Rows is less than 1
CONST MLG_ERR_TOTROWS65000   =  2 'Requested Total Rows is more than allowable total rows (65000)
CONST MLG_ERR_TOTCOLS1       =  3 'Requested Total Columns is less than 1
CONST MLG_ERR_TOTCOLS255     =  4 'Requested Total Columns is more than allowable total columns (255)
CONST MLG_ERR_DIMROWS1       =  5 'Requested Dimensioned Rows is less than 1
CONST MLG_ERR_DIMROWS65000   =  6 'Requested Dimensioned Rows is more than allowable total rows (65000)
CONST MLG_ERR_DIMCOLS1       =  7 'Requested Dimensioned Columns is less than 1
CONST MLG_ERR_DIMCOLS255     =  8 'Requested Dimensioned Columns is more than allowable total columns (255)
CONST MLG_ERR_TOTROWSDIMROWS =  9 'Requested Total Rows is greater than Dimensioned Rows
CONST MLG_ERR_TOTCOLSDIMCOLS =  10 'Requested Total Columns is greater than Dimensioned Columns
CONST MLG_ERR_GRIDMEM        =  11 'Access to the grid memory block failed
CONST MLG_ERR_STRMEMREALLOCATION =  12 'ReAllocation of string memory failed
CONST MLG_ERR_ROWMEMREALLOCATION =  13 'ReAllocation of row formatting memory failed
CONST MLG_ERR_EXPARAMCOUNT   =  14 'The string passed did not have enough parameters

 'Parameter Block Constants
CONST MLG_GETCELLARRAY      = -1
CONST MLG_GETPARAMBLOCK     = -2
CONST MLG_CREATEGRID        = -3
CONST MLG_CREATEGRID_DDT    = -4
CONST MLG_INIT              = -5

'WorkSheet Information
CONST MLG_SHEET_GETNUM   = 1
CONST MLG_SHEET_GETNAME  = 2
CONST MLG_SHEET_GETTOT   = 3
CONST MLG_SHEET_GETRIGHT = 4
CONST MLG_SHEET_GETLEFT  = 5
CONST MLG_SHEET_GETFIRST = 6
CONST MLG_SHEET_GETLAST  = 7
CONST MLG_SHEET_GETID = 8
CONST MLG_SHEET_GETNUMFROMID = 9

'Workbook Properties
CONST MLG_USERTABMOVE = 1
CONST MLG_USERTABEDIT = 2

'Format Override Borders
CONST MLG_TOP    = 1
CONST MLG_LEFT   = 2
CONST MLG_BOTTOM = 4
CONST MLG_RIGHT  = 8
CONST MLG_BOX    = 99  ' to be used with MLG_SetFormatOverrideRange wrapper only
CONST MLG_GRID   = 100 ' to be used with MLG_SetFormatOverrideRange wrapper only


'Number Format Overriding predefined masks
CONST MLG_NODECIMAL     = 1  '"#"
CONST MLG_COMMAS        = 2  '"#,"
CONST MLG_COMMASDECIMAL = 3  '"#,.00"
CONST MLG_CURRENCY      = 4  '"$* #,.00"
CONST MLG_PERCENT       = 5  '"0.0%

'********************************************************************
' User Define Types
'********************************************************************
TYPE RowColDataType            'A Row Format is superior to a Column Format
    DEF CellType        AS INT    'Default(text) = 0 , text= 1,checkbox=2,dropdownlist=3,editable dropdownlist=4
    DEF VisWidth        AS INT    'if column, this is the width in pixels (zero is hidden). if row, (not used)
    DEF FormatExtra     AS INT    'various (not used)
    DEF WriteLock       AS INT    'locked <> -1 , unlocked = 0
    DEF FormatColor     AS INT    'RGB of the text (foreground color) of the cell  - zero is black
    DEF FormatCase      AS INT    'No case formatting = 0 , upper case > 0 , lower case < 0
    DEF FormatLength    AS INT    'No Length restriction (CONST MLG_MAXCELLLEN max) = 0 or max characters
    DEF FormatJustify   AS INT    'Left = 0 (default), Right = 1, Center = 2
    DEF FormatNumber    AS FLOAT  'Integer portion is count left of decimal point, decimal is portion right of decimal point ie "8.3"
    DEF Extra           AS INT    'Anything you want, could be used as Record Number in Row
    DEF List            AS UINT   'ASCIIZ PTR    'Used for the list box.
    DEF FormatDate      AS INT    ' 0=mm/dd/yyyy  etc.
    DEF TempHide        AS INT		'Reserved
    DEF SortExtra       AS INT		'Reserved
    DEF PrintUsing      AS INT		'Reserved
ENDTYPE

TYPE FormatOverRide
     DEF MyRGB AS INT
     DEF MyFont AS CHAR     '0 normal, 1 bold, 2 italics
     DEF MyBorder AS CHAR   'bit array 1111 left,top,right,bottom
     DEF MyUsing AS CHAR    'PrintUsing on Numeric Fields   1 to CONST MLG_NUMFORMATSTR
     DEF NotUsed AS CHAR
END TYPE

TYPE GridInit
  DEF hFont               AS UINT   'Cell Font
  DEF hFontBold           AS UINT   'For column and row headers
  DEF hFontItalic         AS UINT   'For Italic Font
  DEF cyCharEx            AS INT    'Added to pixel height of the font for more room in the cell
  DEF CellBkColorRGB      AS INT    'Cells Background Color
  DEF CellLineColorRGB    AS INT    'Cell Line Color
  DEF WindowBkColorRGB    AS INT    'Window Background Color outside of cell area
  DEF RCHiLiteRGB         AS INT    'If user wishes to high as row or column
  DEF UserData            AS INT    'Use for anything you wish
END TYPE

TYPE NMHDR
	DEF hwndFrom AS INT
	DEF idfrom AS INT
	DEF code AS INT
ENDTYPE

TYPE MyGridData
   DEF NMHeader AS NMHDR
   DEF Param1 AS INT
   DEF Param2 AS INT
   DEF Param3 AS INT
   DEF Param4 AS INT
ENDTYPE

DECLARE IMPORT,MLG_Init ALIAS MLG_INIT()
DECLARE IMPORT,MLG_Put ALIAS MLG_PUTZ (hGrid AS INT,row AS INT,col AS INT, mystr AS STRING,refresh AS INT,OPT sheetnum=0 AS INT)
DECLARE IMPORT,MLG_Get ALIAS MLG_GETZ (hGrid AS INT,row AS INT,col AS INT,OPT sheetnum=0 AS INT),STRING
DECLARE import, MLG_ArrayRedim ALIAS MLG_ARRAYREDIMZ (hGrid AS INT, row AS INT, col AS INT, rowdim AS INT, coldim AS INT),INT
