'********************************************************************
' MyLittleGrid.inc   by James E. Klutho  Copyright May,2006 by James E. Klutho
'********************************************************************
'CONSTANTS
'********************************************************************
'%MLG_STYLE             = 1353711616  '%WS_VISIBLE OR %WS_BORDER OR %WS_CHILD OR %WS_VSCROLL OR %WS_HSCROLL
%MLG_STYLE              = %WS_VISIBLE OR %WS_BORDER OR %WS_CHILD' or %WS_CLIPCHILDREN 'or %WS_CLIPSIBLINGS

%MLG_NULL              = 0
%MLG_MAXCELLLEN        = 1024
'Command Messages
%MLG_REFRESH           = %WM_USER + 1
%MLG_MAKEDEFHEADERS    = %WM_USER + 2
%MLG_INSERTCOLBEFORE   = %WM_USER + 3
%MLG_INSERTCOLAFTER    = %WM_USER + 4
%MLG_INSERTROWBEFORE   = %WM_USER + 5
%MLG_INSERTROWAFTER    = %WM_USER + 6
%MLG_DELETECOLS        = %WM_USER + 7
%MLG_DELETEROWS        = %WM_USER + 8
%MLG_REDIMARRAY        = %WM_USER + 9
%MLG_MAKELONG          = %WM_USER + 10
%MLG_CLEARGRID         = %WM_USER + 11
%MLG_UNDO              = %WM_USER + 12
%MLG_REDIMARRAYEX      = %WM_USER + 13
%MLG_HIDECOLUMN        = %WM_USER + 14
%MLG_SORT              = %WM_USER + 15
'Set Data Messages
%MLG_SETNUMFORMATROW   = %WM_USER + 16
%MLG_SETNUMFORMATCOL   = %WM_USER + 17
%MLG_SETWORKBOOKPROP   = %WM_USER + 18
%MLG_SETSELECTED       = %WM_USER + 20
%MLG_SETROWFORMAT      = %WM_USER + 21
%MLG_SETTOPROW         = %WM_USER + 22
%MLG_SETCOLFORMAT      = %WM_USER + 23
%MLG_SETROWCOLTEMPLATE = %WM_USER + 24
%MLG_SETGRIDEXSTYLE    = %WM_USER + 25
%MLG_SETDIRTYFLAG      = %WM_USER + 26
%MLG_SETLEFTCOL        = %WM_USER + 27
%MLG_SETSKIPRECFLAG    = %WM_USER + 28
%MLG_SETROWEXTRA       = %WM_USER + 29
%MLG_SETCOLEXTRA       = %WM_USER + 30
%MLG_SETCOLWIDTH       = %WM_USER + 31
%MLG_SETCELL           = %WM_USER + 32 'SendMessage cntl, %MLG_SETCELL, MAKLNG(row,col),varptr(asciiz))
%MLG_SETCELLR          = %WM_USER + 33
%MLG_SETDIRTYFLAGZERO  = %WM_USER + 34
%MLG_SETNUMFORMATSTR   = %WM_USER + 35
%MLG_SETCELLEX         = %WM_USER + 36 'zstring in zBuffer
%MLG_SETCELLREX        = %WM_USER + 37 'zstring in zBuffer
%MLG_SETBUFFER         = %WM_USER + 38 'zBuffer
%MLG_SETHEADERCOLOR    = %WM_USER + 39
'Get Data Messages
%MLG_GETWORKBOOKPROP   = %WM_USER + 19
%MLG_GETSELECTED       = %WM_USER + 40
%MLG_GETROWFORMAT      = %WM_USER + 41
%MLG_GETTOPROW         = %WM_USER + 42
%MLG_GETCOLFORMAT      = %WM_USER + 43
%MLG_GETDIRTYFLAG      = %WM_USER + 44
%MLG_GETROWCOLTOT      = %WM_USER + 45
%MLG_GETROWCOLDIM      = %WM_USER + 46
%MLG_GETLEFTCOL        = %WM_USER + 47
%MLG_GETOLDCELL        = %WM_USER + 48
%MLG_GETUNDO           = %WM_USER + 49
%MLG_GETCELLTYPE       = %WM_USER + 50
%MLG_GETROWEXTRA       = %WM_USER + 51
%MLG_GETCOLEXTRA       = %WM_USER + 52
%MLG_GETCOLWIDTH       = %WM_USER + 53
%MLG_GETCELL           = %WM_USER + 54
%MLG_GETBUILD          = %WM_USER + 55
%MLG_GETROWCOLALLBLOCKSEL   = %WM_USER + 56
%MLG_GETROWBLOCKSEL    = %WM_USER + 57
%MLG_GETCOLBLOCKSEL    = %WM_USER + 58
%MLG_GETMENUHANDLE     = %WM_USER + 59
%MLG_GETROWCOLDIMEX    = %WM_USER + 60
%MLG_GETROWCOLTOTEX    = %WM_USER + 61
%MLG_GETROWBLOCKSELEX  = %WM_USER + 62
%MLG_GETCOLBLOCKSELEX  = %WM_USER + 63
%MLG_GETOLDCELLEX      = %WM_USER + 64
%MLG_GETCELLEX         = %WM_USER + 65   'string in buffer
%MLG_GETSELECTEDEX     = %WM_USER + 66
%MLG_GETBUFFER         = %WM_USER + 67
%MLG_GETARRAYPTR       = %WM_USER + 68
%MLG_GETEDITHANDLE     = %WM_USER + 69

'Notifications
%MLGN_RETURN           = %WM_USER + 70
%MLGN_DELETE           = %WM_USER + 71
%MLGN_TAB              = %WM_USER + 72
%MLGN_CHARPRESSED      = %WM_USER + 73
%MLGN_ESCAPEPRESSED    = %WM_USER + 74

%MLGN_ROWDIRTY         = %WM_USER + 75
%MLGN_CELLDIRTY        = %WM_USER + 76
%MLGN_ROWALTERED       = %WM_USER + 77
%MLGN_CELLALTERED      = %WM_USER + 78
%MLGN_DATEPROBLEM      = %WM_USER + 79

%MLGN_CHECKCHANGED     = %WM_USER + 80
%MLGN_COMBOCHANGED     = %WM_USER + 81
%MLGN_COLWIDTHCHANGED  = %WM_USER + 82

%MLGN_SELCHANGE        = %WM_USER + 83
%MLGN_ROWSELCHANGE     = %WM_USER + 84
%MLGN_COLSELCHANGE     = %WM_USER + 85
%MLGN_ROWCOLALLBLOCKSEL= %WM_USER + 86
%MLGN_ROWCHANGE        = %WM_USER + 87

%MLGN_REDIMFAILED      = %WM_USER + 88
%MLGN_WANTNEWREC       = %WM_USER + 89
%MLGN_MADENEWREC       = %WM_USER + 90

%MLGN_RCLICKMENU       = %WM_USER + 91
%MLGN_RIGHTCLICK       = %WM_USER + 92
%MLGN_PASTE            = %WM_USER + 93

%MLGN_SHEETRCLICK      = %WM_USER + 94
%MLGN_SHEETSELECT      = %WM_USER + 95
%MLGN_RCLICKTABMENU    = %WM_USER + 96

%MLGN_SHEETNAMECHANGE  = %WM_USER + 97
%MLGN_SHEETPOSCHANGE   = %WM_USER + 98
%MLGN_SHEETCOLORCHANGE = %WM_USER + 99
%MLGN_SHEETADDED       = %WM_USER + 100
%MLGN_SHEETDELETED     = %WM_USER + 101

%MLGN_COLSIZEDOUBLECLICK   = %WM_USER + 110
%MLGN_THEMECHANGED     = %WM_USER + 111
''Worksheet Messages
%MLG_ADDSHEET          = %WM_USER + 120
%MLG_DELETESHEET       = %WM_USER + 121
%MLG_NAMESHEET         = %WM_USER + 122
%MLG_SELECTSHEET       = %WM_USER + 123
%MLG_SWAPSHEET         = %WM_USER + 124
%MLG_SHOWSHEETTABS     = %WM_USER + 125
%MLG_COLORSHEETTAB     = %WM_USER + 126
%MLG_GETSHEETINFO      = %WM_USER + 127
%MLG_SETSHEETUSER      = %WM_USER + 128
%MLG_GETSHEETUSER      = %WM_USER + 129


'%MLG_SETSELECTEDEX       = %WM_USER + 135


'Format Override   '65000, by 65000 limit
%MLG_CREATEFORMATOVERRIDE  = %WM_USER + 140
%MLG_DELETEFORMATOVERRIDE  = %WM_USER + 141
%MLG_SETFORMATOVERRIDE     = %WM_USER + 142
%MLG_GETFORMATOVERRIDE     = %WM_USER + 143
%MLG_GETFORMATOVERRIDEROWCOL = %WM_USER + 144
%MLG_FREEZE                = %WM_USER + 145

%MLG_UNFREEZEALL       = 0
%MLG_FREEZEROW         = 1
%MLG_UNFREEZEROW       = 2
%MLG_FREEZECOL         = 3
%MLG_UNFREEZECOL       = 4

'Cell Types
%MLG_TYPE_EDIT         = 0 'default  - may be overridden
%MLG_TYPE_EDITFORCE    = 1
%MLG_TYPE_CHECKBOX     = 2
%MLG_TYPE_COMBOSTATIC  = 3
%MLG_TYPE_COMBOEDIT    = 4
'Write Lock
%MLG_NOLOCK            = 0
%MLG_LOCK              = 1
%MLG_LOCK_SKIPROW      = -1 'Will not allow a locked row to be selected
'High Light a row
%MLG_NOHILITE          = 0
%MLG_HILITE            = -1
'Case Formats
%MLG_NOCASE            = 0
%MLG_UCASE             = 1
%MLG_LCASE             = -1
'Justification formats
%MLG_JUST_LEFT         = 0
%MLG_JUST_RIGHT        = 1
%MLG_JUST_CENTER       = 2
'Date formats
%MMDDYYYY              = 1
%MMDDYYYYH             = 2  'Dot instead of a slash
%DDMMYYYY              = 3
%DDMMYYYYH             = 4  'Dot instead of a slash
%MMYYYY                = 5
%MMYYYYH               = 6  'Dot instead of a slash
%YYYYMMDD              = 7
%YYYYMMDDH             = 8  'Dot instead of a slash
%YYYYMM                = 9
%YYYYMMH               = 10  'Dot instead of a slash
'Column Hide
%MLG_HIDECOL           = 0
%MLG_UNHIDECOL         = 1
%MLG_UNHIDEALLCOLS     = 2
'Sorting
%MLG_ASCEND            = 0
%MLG_DESCEND           = 1

'Redimensioning Error Codes

%MLG_ERR_TOTROWS1       =  1 'Requested Total Rows is less than 1
%MLG_ERR_TOTROWS65000   =  2 'Requested Total Rows is more than allowable total rows (65000)
%MLG_ERR_TOTCOLS1       =  3 'Requested Total Columns is less than 1
%MLG_ERR_TOTCOLS255     =  4 'Requested Total Columns is more than allowable total columns (255)
%MLG_ERR_DIMROWS1       =  5 'Requested Dimensioned Rows is less than 1
%MLG_ERR_DIMROWS65000   =  6 'Requested Dimensioned Rows is more than allowable total rows (65000)
%MLG_ERR_DIMCOLS1       =  7 'Requested Dimensioned Columns is less than 1
%MLG_ERR_DIMCOLS255     =  8 'Requested Dimensioned Columns is more than allowable total columns (255)
%MLG_ERR_TOTROWSDIMROWS =  9 'Requested Total Rows is greater than Dimensioned Rows
%MLG_ERR_TOTCOLSDIMCOLS =  10 'Requested Total Columns is greater than Dimensioned Columns
%MLG_ERR_GRIDMEM        =  11 'Access to the grid memory block failed
%MLG_ERR_STRMEMREALLOCATION =  12 'ReAllocation of string memory failed
%MLG_ERR_ROWMEMREALLOCATION =  13 'ReAllocation of row formatting memory failed
%MLG_ERR_EXPARAMCOUNT   =  14 'The string passed did not have enough parameters

 'Parameter Block Constants
%MLG_GETCELLARRAY      = -1
%MLG_GETPARAMBLOCK     = -2
%MLG_CREATEGRID        = -3
%MLG_CREATEGRID_DDT    = -4
%MLG_INIT              = -5

'WorkSheet Information
%MLG_SHEET_GETNUM   = 1
%MLG_SHEET_GETNAME  = 2
%MLG_SHEET_GETTOT   = 3
%MLG_SHEET_GETRIGHT = 4
%MLG_SHEET_GETLEFT  = 5
%MLG_SHEET_GETFIRST = 6
%MLG_SHEET_GETLAST  = 7
%MLG_SHEET_GETID = 8
%MLG_SHEET_GETNUMFROMID = 9

'Workbook Properties
%MLG_USERTABMOVE = 1
%MLG_USERTABEDIT = 2

'Format Override Borders
%MLG_TOP    = 1
%MLG_LEFT   = 2
%MLG_BOTTOM = 4
%MLG_RIGHT  = 8
%MLG_BOX    = 99  ' to be used with MLG_SetFormatOverrideRange wrapper only
%MLG_GRID   = 100 ' to be used with MLG_SetFormatOverrideRange wrapper only


'Number Format Overriding predefined masks
%MLG_NODECIMAL     = 1  '"#"
%MLG_COMMAS        = 2  '"#,"
%MLG_COMMASDECIMAL = 3  '"#,.00"
%MLG_CURRENCY      = 4  '"$* #,.00"
%MLG_PERCENT       = 5  '"0.0%

'********************************************************************
' User Define Types
'********************************************************************
TYPE RowColDataType            'A Row Format is superior to a Column Format
    CellType        AS LONG    'Default(text) = 0 , text= 1,checkbox=2,dropdownlist=3,editable dropdownlist=4
    VisWidth        AS LONG    'if column, this is the width in pixels (zero is hidden). if row, (not used)
    FormatExtra     AS LONG    'various (not used)
    WriteLock       AS LONG    'locked <> -1 , unlocked = 0
    FormatColor     AS LONG    'RGB of the text (foreground color) of the cell  - zero is black
    FormatCase      AS LONG    'No case formatting = 0 , upper case > 0 , lower case < 0
    FormatLength    AS LONG    'No Length restriction (%MLG_MAXCELLLEN max) = 0 or max characters
    FormatJustify   AS LONG    'Left = 0 (default), Right = 1, Center = 2
    FormatNumber    AS SINGLE  'Integer portion is count left of decimal point, decimal is portion right of decimal point ie "8.3"
    Extra           AS LONG    'Anything you want, could be used as Record Number in Row
    List            AS ASCIIZ PTR    'Used for the list box.
    FormatDate      AS LONG     ' 0=mm/dd/yyyy  etc.
    TempHide        AS LONG
    SortExtra       AS LONG
    PrintUsing      AS LONG
END TYPE

TYPE FormatOverRide
     MyRGB AS LONG
     MyFont AS BYTE     '0 normal, 1 bold, 2 italics
     MyBorder AS BYTE   'bit array 1111 left,top,right,bottom
     MyUsing AS BYTE    'PrintUsing on Numeric Fields   1 to %MLG_NUMFORMATSTR
     NotUsed AS BYTE
END TYPE

TYPE GridInit
  hFont               AS DWORD   'Cell Font
  hFontBold           AS DWORD   'For column and row headers
  hFontItalic         AS DWORD   'For Italic Font
  cyCharEx            AS LONG    'Added to pixel height of the font for more room in the cell
  CellBkColorRGB      AS LONG    'Cells Background Color
  CellLineColorRGB    AS LONG    'Cell Line Color
  WindowBkColorRGB    AS LONG    'Window Background Color outside of cell area
  RCHiLiteRGB         AS LONG    'If user wishes to high as row or column
  UserData            AS LONG    'Use for anything you wish
END TYPE


TYPE MyGridData
   NMHeader AS NMHDR
   Param1 AS LONG
   Param2 AS LONG
   Param3 AS LONG
   Param4 AS LONG
END TYPE

TYPE ParamBlock                    'Main block for individual grid data
  s                   AS STRING * %MLG_MAXCELLLEN
  r                   AS LONG
  c                   AS LONG
  a                   AS LONG
  p1                  AS LONG
  p2                  AS LONG
  p3                  AS LONG
  p4                  AS LONG
  p5                  AS LONG
  p6                  AS LONG
END TYPE



 DECLARE FUNCTION MLG LIB "MLG.DLL" ALIAS "MLG" (BYVAL hGrid AS LONG,OPT BYVAL op AS LONG,OPT BYVAL tp AS ParamBlock) AS LONG

 DECLARE FUNCTION MLG_Get LIB "MLG.DLL" ALIAS "MLG_GET" (hGrid AS DWORD,row AS LONG,col AS LONG,OPT BYVAL sheetnum AS LONG) AS STRING
 DECLARE SUB MLG_Put LIB "MLG.DLL" ALIAS "MLG_PUT" (hGrid AS DWORD,row AS LONG,col AS LONG, mystr AS STRING,refresh AS LONG,OPT BYVAL sheetnum AS LONG)
 DECLARE FUNCTION MLG_ArrayRedim LIB "MLG.DLL" ALIAS "MLG_ARRAYREDIM" (BYVAL hGrid AS DWORD, row AS LONG, col AS LONG, rowdim AS LONG, coldim AS LONG)AS LONG
 DECLARE SUB MLG_Init LIB "MLG.DLL" ALIAS "MLG_INIT"
 DECLARE SUB MLG_GetEx LIB "MLG.DLL" ALIAS "MLG_GETEX" (hGrid AS DWORD,s() AS STRING)
 DECLARE SUB MLG_PutEx LIB "MLG.DLL" ALIAS "MLG_PUTEX" (hGrid AS DWORD,s()AS STRING,op AS LONG, refresh AS LONG)
 DECLARE FUNCTION MLG_SetProperty LIB "MLG.DLL" ALIAS "MLG_SETPROPERTY" (BYVAL hGrid AS LONG, BYVAL PROPERTY AS STRING, BYVAL thevalue1 AS LONG, BYVAL thevalue2 AS LONG, BYVAL thestr AS STRING)AS LONG

SUB MLG_FormatColCheck(hGrid AS DWORD,col AS LONG)
   LOCAL totals AS LONG
   LOCAL totcols AS LONG
   LOCAL RC AS RowColDataType

   totals=SendMessage(hGrid,%MLG_GETROWCOLTOT,0,0)
   totcols=HIWRD(totals)
   IF col < 1 OR col > totcols THEN EXIT SUB
   SendMessage hGrid, %MLG_GETCOLFORMAT,col,VARPTR(RC)
   RC.CellType = %MLG_TYPE_CHECKBOX
   SendMessage hGrid, %MLG_SETCOLFORMAT,col,VARPTR(RC)
END SUB

SUB MLG_FormatColCombo(hGrid AS DWORD,col AS LONG,liststr AS STRING,OPT BYVAL op AS LONG)
   LOCAL totals AS LONG
   LOCAL totcols AS LONG
   LOCAL RC AS RowColDataType
   LOCAL zlist AS ASCIIZ * 256

   totals=SendMessage(hGrid,%MLG_GETROWCOLTOT,0,0)
   totcols=HIWRD(totals)
   IF col < 1 OR col > totcols THEN EXIT SUB
   SendMessage hGrid, %MLG_GETCOLFORMAT,col,VARPTR(RC)
   IF op<>0 THEN RC.CellType = %MLG_TYPE_COMBOSTATIC ELSE RC.CellType = %MLG_TYPE_COMBOEDIT
   zlist= liststr
   RC.List=VARPTR(zlist)
   SendMessage hGrid, %MLG_SETCOLFORMAT,col,VARPTR(RC)
END SUB

SUB MLG_FormatColDate(hGrid AS DWORD,col AS LONG,datetype AS LONG,OPT BYVAL justify AS LONG,OPT BYVAL mycolor AS LONG,OPT BYVAL writelock AS LONG)
   LOCAL totals AS LONG
   LOCAL totcols AS LONG
   LOCAL RC AS RowColDataType


   totals=SendMessage(hGrid,%MLG_GETROWCOLTOT,0,0)
   totcols=HIWRD(totals)
   IF col < 1 OR col > totcols THEN EXIT SUB
   SendMessage hGrid, %MLG_GETCOLFORMAT,col,VARPTR(RC)
   RC.CellType = %MLG_TYPE_EDITFORCE
   RC.FormatDate=datetype
   RC.FormatJustify=justify
   RC.FormatColor=mycolor
   RC.WriteLock=writelock
   SendMessage hGrid, %MLG_SETCOLFORMAT,col,VARPTR(RC)
END SUB

SUB MLG_FormatColNumber(hGrid AS DWORD,col AS LONG,n AS SINGLE,OPT BYVAL justify AS LONG,OPT BYVAL mycolor AS LONG,OPT BYVAL writelock AS LONG)
   LOCAL totals AS LONG
   LOCAL totcols AS LONG
   LOCAL RC AS RowColDataType


   totals=SendMessage(hGrid,%MLG_GETROWCOLTOT,0,0)
   totcols=HIWRD(totals)
   IF col < 1 OR col > totcols THEN EXIT SUB
   SendMessage hGrid, %MLG_GETCOLFORMAT,col,VARPTR(RC)
   RC.CellType = %MLG_TYPE_EDITFORCE
   RC.FormatNumber=n
   RC.FormatJustify=justify
   RC.FormatColor=mycolor
   RC.WriteLock=writelock
   SendMessage hGrid, %MLG_SETCOLFORMAT,col,VARPTR(RC)
END SUB

SUB MLG_FormatColEdit(hGrid AS DWORD,col AS LONG,mylength AS LONG,mycase AS LONG,OPT BYVAL justify AS LONG,OPT BYVAL mycolor AS LONG,OPT BYVAL writelock AS LONG)
   LOCAL totals AS LONG
   LOCAL totcols AS LONG
   LOCAL RC AS RowColDataType

   totals=SendMessage(hGrid,%MLG_GETROWCOLTOT,0,0)
   totcols=HIWRD(totals)
   IF col < 1 OR col > totcols THEN EXIT SUB
   SendMessage hGrid, %MLG_GETCOLFORMAT,col,VARPTR(RC)
   RC.CellType = 0
   RC.FormatLength=mylength
   RC.FormatCase=mycase
   RC.FormatJustify=justify
   RC.FormatColor=mycolor
   RC.WriteLock=writelock
   SendMessage hGrid, %MLG_SETCOLFORMAT,col,VARPTR(RC)
END SUB

SUB MLG_FormatColTitles(hGrid AS DWORD,liststr AS STRING)
   LOCAL totals AS LONG
   LOCAL totcols AS LONG
   LOCAL COUNT AS LONG
   LOCAL x AS LONG
   LOCAL zlist AS ASCIIZ * 255

   totals=SendMessage(hGrid,%MLG_GETROWCOLTOT,0,0)
   totcols=HIWRD(totals)

   COUNT=PARSECOUNT(liststr)
   COUNT=MIN&(COUNT,totcols)
   FOR x=1 TO COUNT
      zlist=PARSE$(liststr,x)
      SendMessage hGrid,%MLG_SETCELL,MAKLNG(0,x),VARPTR(zlist)
   NEXT x
END SUB

SUB MLG_SetRowRecNo(hGrid AS DWORD,row AS LONG,RecNo AS LONG)
   LOCAL totals AS LONG
   LOCAL totrows AS LONG

   totals=SendMessage(hGrid,%MLG_GETROWCOLTOT,0,0)
   totrows=LOWRD(totals)
   IF row < 1 OR row > totrows THEN EXIT SUB

   SendMessage hGrid, %MLG_SETROWEXTRA,row,RecNo
END SUB

FUNCTION MLG_GetRowRecNo(hGrid AS DWORD,row AS LONG)AS LONG
   LOCAL totals AS LONG
   LOCAL totrows AS LONG

   FUNCTION=0
   totals=SendMessage(hGrid,%MLG_GETROWCOLTOT,0,0)
   totrows=LOWRD(totals)
   IF row < 1 OR row > totrows THEN EXIT FUNCTION

   FUNCTION=SendMessage(hGrid,%MLG_GETROWEXTRA,row,0)
END FUNCTION

SUB MLG_FormatRowHighLight(hGrid AS DWORD,row AS LONG,OPT BYVAL hilite AS LONG)
   LOCAL totals AS LONG
   LOCAL totrows AS LONG
   LOCAL RC AS RowColDataType

   totals=SendMessage(hGrid,%MLG_GETROWCOLTOT,0,0)
   totrows=LOWRD(totals)
   IF row < 1 OR row > totrows THEN EXIT SUB
   SendMessage hGrid, %MLG_GETROWFORMAT,row,VARPTR(RC)
   RC.FormatExtra = hilite
   SendMessage hGrid, %MLG_SETROWFORMAT,row,VARPTR(RC)
END SUB

SUB MLG_FormatColHighLight(hGrid AS DWORD,col AS LONG,OPT BYVAL hilite AS LONG)
   LOCAL totals AS LONG
   LOCAL totcols AS LONG
   LOCAL RC AS RowColDataType

   totals=SendMessage(hGrid,%MLG_GETROWCOLTOT,0,0)
   totcols=HIWRD(totals)
   IF col < 1 OR col > totcols THEN EXIT SUB
   SendMessage hGrid, %MLG_GETCOLFORMAT,col,VARPTR(RC)
   RC.FormatExtra = hilite
   SendMessage hGrid, %MLG_SETCOLFORMAT,col,VARPTR(RC)
END SUB



SUB MLG_FormatGridex(hGrid AS DWORD,CellBkColorRGB AS LONG,WindowBkColorRGB AS LONG, CellLineColorRGB AS LONG, hFont AS LONG, hFontBold AS LONG, hFontItalic AS LONG, cyCharEx AS LONG,RCHighLightRGB AS LONG,UserData AS LONG)
   LOCAL GI AS GridInit

   GI.hFont=hFont
   GI.hFontBold=hFontBold
   GI.hFontItalic=hFontItalic
   GI.cyCharEx=cyCharEx
   GI.CellBkColorRGB=CellBkColorRGB
   GI.CellLineColorRGB=CellLineColorRGB
   GI.WindowBkColorRGB=WindowBkColorRGB
   GI.RCHiLiteRGB=RCHighLightRGB
   GI.UserData=UserData
   SendMessage hGrid, %MLG_SETGRIDEXSTYLE, VARPTR(GI), 0
END SUB

SUB MLG_SetFormatOverrideRange(hGrid AS DWORD,row1 AS LONG,col1 AS LONG,row2 AS LONG, col2 AS LONG, _
    MyRGB AS LONG,MyFont AS BYTE,MyBorder AS BYTE,MyUsing AS BYTE)

   LOCAL y1,x1,y2,x2,x,y AS LONG
   LOCAL fo AS FormatOverride
   LOCAL totrows, totcols,totals,c,doBox,doGrid AS LONG
   LOCAL f,b,u,tempxborder AS BYTE

   x1=MIN(col1,col2)
   y1=MIN(row1,row2)
   x2=MAX(col1,col2)
   y2=MAX(row1,row2)

   c=MyRGB
   IF c < 0 THEN c = 0
   f=MyFont
   IF f < 0 THEN f = 0
   IF f > 2 THEN f = 2
   u=MyUsing
   IF u < 0 THEN u = 0
   IF u > 20 THEN u = 20

   'MyBorder is negative then box in the range.  This
   b=MyBorder
   IF MyBorder =99 THEN doBox=1 : b=0
   IF MyBorder =100 THEN doGrid=1 : b=0


   totals=SendMessage(hGrid,%MLG_GETFORMATOVERRIDEROWCOL,0,0)

   totcols=HIWRD(totals)
   IF x1 < 1 OR x2 > totcols THEN EXIT SUB
   totrows=LOWRD(totals)
   IF y1 < 1 OR y2 > totrows THEN EXIT SUB

   fo.MyRGB = c
   fo.MyFont=f
   fo.MyUsing=u
   fo.MyBorder=b


   FOR x=x1 TO x2
       IF dobox THEN
           fo.MyBorder=0
           IF x=x1 THEN fo.MyBorder=%MLG_LEFT
           IF x=x2 THEN fo.MyBorder=%MLG_RIGHT OR fo.MyBorder
           tempxborder=fo.MyBorder
       END IF
       IF doGrid THEN
           fo.MyBorder=0
           fo.MyBorder=%MLG_LEFT
           IF x=x2 THEN fo.MyBorder=%MLG_RIGHT OR fo.MyBorder
           tempxborder=fo.MyBorder
       END IF
       FOR y=y1 TO y2
            IF dobox THEN
                fo.MyBorder=tempxborder
               IF y=y1 THEN fo.MyBorder=%MLG_TOP OR tempxborder
               IF y=y2 THEN fo.MyBorder=%MLG_BOTTOM OR tempxborder OR fo.MyBorder
            END IF
            IF doGrid THEN
               fo.MyBorder=tempxborder
               fo.MyBorder=%MLG_TOP OR tempxborder
               IF y=y2 THEN fo.MyBorder=%MLG_BOTTOM OR tempxborder OR fo.MyBorder
            END IF
            SendMessage hGrid, %MLG_SETFORMATOVERRIDE,MAKLNG(y,x),VARPTR(fo)
       NEXT y
   NEXT x

END SUB

SUB MLG_CopyRowBlockToClipBoard(hGrid AS LONG,OPT BYVAL CopyColHeader AS LONG,OPT BYVAL AllowAllRowsCols AS LONG)
    LOCAL startblock,endblock AS LONG
    LOCAL totrows,totcols AS LONG
    LOCAL flag,I,x,y,rowlimit,skey AS LONG
    LOCAL mystr AS STRING
    LOCAL stLen AS LONG, hData AS LONG, hGlob AS LONG, mg AS LONG

   #IF %DEF(%WINAPI) 'This sub require WINAPI
    rowlimit = 5000   'Adjust to suit.  This prevents accidently trying to copy 2,000,000,000,000 rows

    SendMessage hGrid ,%MLG_GETROWCOLTOTEX,VARPTR(totrows),VARPTR(totcols)
    flag = SendMessage (hGrid, %MLG_GETROWCOLALLBLOCKSEL, 0 ,0)
    IF flag = 1 AND AllowAllRowsCols <> 0 THEN 'The whole grid has been selected - this could be a problem with selecting many NULL rows
       startblock = 1
       endblock = totrows
      ELSE   'The whole grid is not selected so check for a row block being selected
        SendMessage hGrid ,%MLG_GETROWBLOCKSELEX,VARPTR(startblock),VARPTR(endblock)
    END IF

    IF startblock > 0 AND endblock > 0 AND (endblock - startblock) < rowlimit THEN
       'Only copy visible columns
       DIM widths(totcols) AS LONG
       mystr=""
       FOR I = 1 TO totcols
         widths(I)=SendMessage(hGrid,%MLG_GETCOLWIDTH,I,0)
       NEXT I

       IF CopyColHeader > 0 THEN
          FOR x= 1 TO totcols
             IF widths(x) > 0 THEN
                 mystr=mystr & MLG_Get(hGrid,y,x)& $TAB
             END IF
           NEXT x
           mystr=mystr & $CRLF
       END IF
       MOUSEPTR 11 'Hourglass - this needs a progress bar like MS Access
       FOR y = startblock TO endblock
           skey=GetKeyState(%VK_ESCAPE) AND &H8000
           IF skey<>0 THEN EXIT SUB
           FOR x= 1 TO totcols
             IF widths(x) > 0 THEN
                 mystr=mystr & MLG_Get(hGrid,y,x)& $TAB
             END IF
           NEXT x
           mystr=mystr & $CRLF
       NEXT y
       MOUSEPTR 1 'Arrow
    END IF


    stLen = LEN(mystr)
    ' Create a global memory object and copy the data into it
    hData = GlobalAlloc(%GMEM_MOVEABLE OR %GMEM_DDESHARE, stLen + 1)
    hGlob = GlobalLock(hData)
    mg = STRPTR(mystr)
    MoveMemory BYVAL hGlob, BYVAL mg, BYVAL stLen
    GlobalUnlock hData

     ' Open the clipboard
    IF ISFALSE (OpenClipboard(%NULL)) THEN
        GlobalFree hData
        EXIT SUB
    END IF

    ' Paste the data into the clipboard
    EmptyClipboard
    SetClipboardData %CF_TEXT, hData
    CloseClipboard
 #ENDIF

END SUB

SUB MLG_HideColBlock(hGrid AS LONG)
    LOCAL startblock,endblock AS LONG
    LOCAL totrows,totcols AS LONG
    LOCAL flag,I,K AS LONG

    SendMessage hGrid ,%MLG_GETROWCOLTOTEX,VARPTR(totrows),VARPTR(totcols)
    flag = SendMessage (hGrid, %MLG_GETROWCOLALLBLOCKSEL, 0 ,0)
    IF flag = 1 THEN 'The whole grid has been selected - this not allowed
       startblock = 0
       endblock = 0
      ELSE   'The whole grid is not selected so check for a column block being selected
        SendMessage hGrid ,%MLG_GETCOLBLOCKSELEX,VARPTR(startblock),VARPTR(endblock)
        IF startblock > 0 AND endblock > 0 THEN

           FOR I = startblock TO endblock 'Do not temporarily hide a column already at zero width
             K = SendMessage(hGrid,%MLG_GETCOLWIDTH,I,0)
             IF K <> 0 THEN SendMessage hGrid,%MLG_HIDECOLUMN ,%MLG_HIDECOL,I
           NEXT I

        END IF
    END IF
END SUB

SUB MLG_SetColMaxLen(BYVAL hGrid AS LONG, col AS LONG,OPT BYVAL ConsiderHeader AS LONG )
    LOCAL hDC AS LONG
    LOCAL mysize AS SIZEL
    LOCAL result AS LONG
    LOCAL s AS ASCIIZ * 255
    LOCAL TotRows AS LONG
    LOCAL TotCols AS LONG
    LOCAL maxlen AS LONG
    LOCAL myrow,mycol AS LONG
    LOCAL mycount AS LONG
    LOCAL startRow, endRow AS LONG
    maxlen = 0

    SendMessage (hGrid,%MLG_GETROWCOLTOTEX,VARPTR(TotRows),VARPTR(TotCols))
    endRow=TotRows : StartRow = 1
    IF ConsiderHeader <> 0 THEN
         StartRow = 0
        ELSE
         StartRow = 1
    END IF
    IF col < 1 OR col > TotCols THEN EXIT SUB

    hDC=GetDC(hGrid)

    FOR mycount = StartRow TO EndRow
      s=MLG_Get(hGrid,mycount,col)
      result=GetTextExtentPoint32(hDC,s,LEN(s),mysize)
      maxlen = MAX(maxLen,mysize.cx)
    NEXT mycount
    maxlen = MIN(maxlen,255)
    IF maxlen > 5 THEN
        SendMessage hGrid,%MLG_SETCOLWIDTH,col,maxlen
        SendMessage hGrid,%MLG_REFRESH,0,0
    END IF
    ReleaseDC(hGrid,hDC)
END SUB
